//Working 11/Nov/2016
#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266HTTPClient.h>

IPAddress ip(172,16,3,4);
IPAddress dns(172,16,0,1);
IPAddress gw(172,16,0,1);
IPAddress mask(255,255,0,0);

#define INT_PIN 14//;12
#define GPIO_IN ((volatile uint32_t*) 0x60000318)
const char* ssid = "test";
const char* pass = "test";

volatile unsigned int score[500];

byte score_index=0;

char hiscore[12];


HTTPClient http;

void read_score();
void send_score();
int isReset();
int isHighScore();


void setup(void)
{

  Serial.begin(115200);
    WiFi.mode(WIFI_STA);
//  WiFi.begin(ssid, password);
  Serial.println("");

  WiFi.config(ip, dns, gw, mask); 
  WiFi.begin(ssid,pass);
  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) 
  {
    
    delay(500);
    Serial.print(".");
  }
 
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.println("IP address: ");
  //Serial.println(WiFi.localIP());

  pinMode(INT_PIN,INPUT);
  pinMode(0,INPUT);
  pinMode(2,INPUT);
  pinMode(3,INPUT);
  pinMode(4,INPUT);
  pinMode(5,INPUT);
  pinMode(12,INPUT);
  pinMode(13,INPUT);
  pinMode(14,INPUT);
  pinMode(15,INPUT);
  pinMode(16,INPUT);        
  //delay(9000);
  attachInterrupt(INT_PIN, read_score, CHANGE);//FALLING);

}

void loop()
{
  byte i;

  unsigned int k;
  int j;

  
  if(isHighScore()) //digitalRead(15))
  {
    Serial.print("score_index:");Serial.println(score_index);
    delay(31000);
    if(score_index > 11)
    { 
      i = 0;
      for(j=(score_index - 12);j<(score_index);j++)
      {   
         
          // Converts Galaga Character Codes to ASCII
          //1D - D4
          //2D - D5
          //3D - D12
          //4D - D13
          //5D - D2
          //6D - D0
          hiscore[i] = 'd';
          k = 0b0011000000110101 & score[j];
          if( k == 0x0000) hiscore[i] = '0';
          if( k == 0x0010) hiscore[i] = '1';
          if( k == 0x0020) hiscore[i] = '2';
          if( k == 0x0030) hiscore[i] = '3';
          if( k == 0x1000) hiscore[i] = '4';
          if( k == 0x1010) hiscore[i] = '5';
          if( k == 0x1020) hiscore[i] = '6';
          if( k == 0x1030) hiscore[i] = '7';        
          if( k == 0x2000) hiscore[i] = '8';        
          if( k == 0x2010) hiscore[i] = '9';   
          if( k == 0x2020) hiscore[i] = 'A';   
          if( k == 0x2030) hiscore[i] = 'B';   
          if( k == 0x3000) hiscore[i] = 'C';   
          if( k == 0x3010) hiscore[i] = 'D';   
          if( k == 0x3020) hiscore[i] = 'E';   
          if( k == 0x3030) hiscore[i] = 'F';   
          if( k == 0x0004) hiscore[i] = 'G';   
          if( k == 0x0014) hiscore[i] = 'H';   
          if( k == 0x0024) hiscore[i] = 'I';   
          if( k == 0x0034) hiscore[i] = 'J';   
          if( k == 0x1004) hiscore[i] = 'K';   
          if( k == 0x1014) hiscore[i] = 'L';   
          if( k == 0x1024) hiscore[i] = 'M';   
          if( k == 0x1034) hiscore[i] = 'N';   
          if( k == 0x2004) hiscore[i] = 'O';   
          if( k == 0x2014) hiscore[i] = 'P';   
          if( k == 0x2024) hiscore[i] = 'Q';   
          if( k == 0x2034) hiscore[i] = 'R';   
          if( k == 0x3004) hiscore[i] = 'S';   
          if( k == 0x3014) hiscore[i] = 'T';   
          if( k == 0x3024) hiscore[i] = 'U';   
          if( k == 0x3034) hiscore[i] = 'V';   
               
          if( k == 0x0001) hiscore[i] = 'W';   
          if( k == 0x0011) hiscore[i] = 'X';   
          if( k == 0x0021) hiscore[i] = 'Y';   
          if( k == 0x0031) hiscore[i] = 'Z';   
          if( k == 0x1001) hiscore[i] = 'b'; //" "   
          if( k == 0x2021) hiscore[i] = 'c'; //"."
          Serial.print(j);Serial.print(":");Serial.println(hiscore[i]);
          i++;  
        }
      }
    score_index = 0;
    send_score();
    
  }
}


void send_score()
{
    Serial.println("[HTTP] begin...\n");
    String request =  String("/cgi-bin/galagaHS.pl?hs=") + hiscore;// + "&ini=" + initials;
 
    http.begin("172.16.0.20", 80, request ); //HTTP

    Serial.println("[HTTP] GET...\n");
    // start connection and send HTTP header
    int httpCode = http.GET();
    
    // httpCode will be negative on error
    if(httpCode > 0) 
    {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTP] GET... code: %d\n", httpCode);
      
      // file found at server
      if(httpCode == HTTP_CODE_OK) 
      {
          String payload = http.getString();
          Serial.println(payload);
      }
      else 
      {
          Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
      }
      http.end();
  }
}

void read_score()
{
  score[score_index++]=(unsigned int)*GPIO_IN;

}

int isReset()
{       
  unsigned int pattern[9]= {0x0000,0x0000,0x0000,0x0000,0x0020,0x1001,0x1034,0x2021,0x1034};
  int i;
  int j;
  j = 0;
  for(i=0;i<score_index;i++)
  {
    if((score[i]&0b0011000000110101) == pattern[j])
    {
      j++;
      if(j==8)
        return 8;
    }
    else
    {
      j = 0;
    }
  }
  //Serial.print("jjjj:");Serial.println(j,HEX);
 return 0;
}

int isHighScore()
{       
  //#define plen 3
  unsigned int pattern[3]= {0x1001,0x1001,0x1001};
  int spos;
  int ppos;
  ppos = 0;
  for(spos=0;spos < (score_index);spos++)
  {
    if((score[spos]&0b0011000000110101) == pattern[ppos])
    {
      ppos++;
      if(ppos==3)
        return spos;
    }
    else
    {
      //spos -= ppos;
      ppos = 0;
    }
  }
 return 0;
}

